-- Load Libraries
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

-- Defense Stats
local Dodge_Frame = ldb:NewDataObject("StatsNow - Dodge", {type = "data source", label = "Dodge", text = "", icon = "Interface\\Icons\\Spell_Shadow_ShadowWard"})
local Parry_Frame = ldb:NewDataObject("StatsNow - Parry", {type = "data source", label = "Parry", text = "", icon = "Interface\\Icons\\Ability_Parry"})
local Block_Frame = ldb:NewDataObject("StatsNow - Block", {type = "data source", label = "Block", text = "", icon = "Interface\\Icons\\Ability_Defend"})
local Defense_Frame = ldb:NewDataObject("StatsNow - Defense", {type = "data source", label = "Defense", text = "", icon = "Interface\\Icons\\Spell_Holy_LastingDefense"})
local Armor_Defense_Frame = ldb:NewDataObject("StatsNow - Armor", {type = "data source", label = "Armor", text = "", icon = "Interface\\Icons\\Spell_DeathKnight_BladedArmor"})

-- Defense Frames
local Dodge = CreateFrame("frame")
local Parry = CreateFrame("frame")
local Block = CreateFrame("frame")
local Defense = CreateFrame("frame")
local Armor_Defense = CreateFrame("frame")


-- Data Input
Dodge:SetScript("OnUpdate", function(self, elap)
	local Total_Dodge = GetDodgeChance()
	Dodge_Frame.text = string.format("%.2f%%", Total_Dodge)
end)

Parry:SetScript("OnUpdate", function(self, elap)
	local Total_Parry = GetParryChance()
	Parry_Frame.text = string.format("%.2f%%", Total_Parry)
end)

Block:SetScript("OnUpdate", function(self, elap)
	local Total_Block = GetBlockChance()
	Block_Frame.text = string.format("%.2f%%", Total_Block)
end)

Defense:SetScript("OnUpdate", function(self, elap)
	local baseDefense, additionalDefense = UnitDefense("player")
	local Defense = baseDefense + additionalDefense
	Defense_Frame.text = string.format("%.0f", Defense)
end)

Armor_Defense:SetScript("OnUpdate", function(self, elap)
	local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player")
	local Melee_Reduction = effectiveArmor
	Armor_Defense_Frame.text = Melee_Reduction
end)